'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _SVGClear = require('./svg/SVGClear');

var _SVGClear2 = _interopRequireDefault(_SVGClear);

var _SVGDone = require('./svg/SVGDone');

var _SVGDone2 = _interopRequireDefault(_SVGDone);

var _SVGAdd = require('./svg/SVGAdd');

var _SVGAdd2 = _interopRequireDefault(_SVGAdd);

var _SVGRemove = require('./svg/SVGRemove');

var _SVGRemove2 = _interopRequireDefault(_SVGRemove);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _helperFunctions = require('./helperFunctions');

var _defaultStyles = require('./defaultStyles');

var _SVGCancel = require('./svg/SVGCancel');

var _SVGCancel2 = _interopRequireDefault(_SVGCancel);

var _SVGCross = require('./svg/SVGCross');

var _SVGCross2 = _interopRequireDefault(_SVGCross);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = function Button(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === undefined ? 'default' : _ref$type,
      _ref$transition = _ref.transition,
      transition = _ref$transition === undefined ? 'smooth' : _ref$transition,
      children = _ref.children,
      containerRef = _ref.containerRef,
      className = _ref.className,
      style = _ref.style,
      isOn = _ref.isOn,
      onClick = _ref.onClick,
      isMouseOver = _ref.isMouseOver,
      setIsMouseOver = _ref.setIsMouseOver,
      _ref$settings = _ref.settings,
      settings = _ref$settings === undefined ? {} : _ref$settings,
      props = (0, _objectWithoutProperties3.default)(_ref, ['type', 'transition', 'children', 'containerRef', 'className', 'style', 'isOn', 'onClick', 'isMouseOver', 'setIsMouseOver', 'settings']);

  var getClassName = function getClassName(_ref2) {
    var className = _ref2.className,
        isOn = _ref2.isOn,
        isDisabled = _ref2.isDisabled;

    var baseClass = 'button button--' + type;
    var baseDisabledClass = 'button--disabled button--' + type + '--disabled';
    var baseToggleClass = 'button--' + type + '--' + (isOn ? 'on' : 'off');
    if (!isDisabled) {
      if (typeof isOn !== 'undefined') {
        if (typeof className !== 'undefined') {
          return baseClass + ' ' + baseToggleClass + ' ' + className + ' ' + className + '--' + (isOn ? 'on' : 'off');
        } else {
          return baseClass + ' ' + baseToggleClass;
        }
      } else {
        if (typeof className !== 'undefined') {
          return baseClass + ' ' + className;
        } else {
          return '' + baseClass;
        }
      }
    } else {
      if (typeof className !== 'undefined') {
        return baseClass + ' ' + baseDisabledClass + ' ' + className + ' ' + className + '--disabled';
      } else {
        return baseClass + ' ' + baseDisabledClass;
      }
    }
  };

  var getButtonProps = function getButtonProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref3.onClick,
        className = _ref3.className,
        style = _ref3.style,
        isDisabled = _ref3.isDisabled,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'className', 'style', 'isDisabled']);

    var getTransitionStyle = function getTransitionStyle() {
      switch (transition) {
        case 'smooth':
          return {
            color: isOn ? isMouseOver ? settings.on.color : (0, _helperFunctions.lightenDarken)(settings.on.color, settings.diff) : isMouseOver ? settings.off.color : (0, _helperFunctions.lightenDarken)(settings.off.color, -settings.diff),
            background: isOn ? isMouseOver ? settings.on.background : (0, _helperFunctions.lightenDarken)(settings.on.background, -settings.diff) : isMouseOver ? settings.off.background : (0, _helperFunctions.lightenDarken)(settings.off.background, settings.diff)
          };
        case 'contrast':
          return {
            color: isOn ? isMouseOver ? settings.on.color : (0, _helperFunctions.lightenDarken)(settings.on.color, settings.diff) : isMouseOver ? settings.off.color : (0, _helperFunctions.lightenDarken)(settings.off.color, -settings.diff),
            background: isOn ? isMouseOver ? (0, _helperFunctions.lightenDarken)(settings.off.background, -settings.diff) : settings.on.background : isMouseOver ? (0, _helperFunctions.lightenDarken)(settings.on.background, settings.diff) : settings.off.background
          };
        default:
          break;
      }
    };
    var getDefaultStyle = function getDefaultStyle() {
      return (0, _extends3.default)({
        transition: 'background-color 250ms ease-in-out',
        alignItems: 'center',
        fontSize: '1.5rem',
        height: '2rem',
        justifyContent: 'center',
        display: 'flex',
        cursor: 'pointer'
      }, getTransitionStyle(), settings.constant);
    };
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      style: (0, _extends3.default)({}, getDefaultStyle(), style),
      onMouseOver: function onMouseOver() {
        setIsMouseOver(true);
      },
      onMouseLeave: function onMouseLeave() {
        setIsMouseOver(false);
      },
      className: getClassName({ className: className, isOn: isOn, isDisabled: isDisabled })
    }, props);
  };
  var renderChildren = function renderChildren(type) {
    var icon = void 0;
    switch (type) {
      case 'caretdropdown':
        icon = isOn ? _react2.default.createElement(_SVGExpandLess2.default, { style: { pointerEvents: 'none' } }) : _react2.default.createElement(_SVGExpandMore2.default, { style: { pointerEvents: 'none' } });
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver, icon: icon }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps({
            onClick: onClick,
            className: className,
            style: (0, _extends3.default)({ justifyContent: 'space-between' }, style)
          })),
          _react2.default.createElement(
            'div',
            { style: { display: 'flex', justifyContent: 'space-between' } },
            children
          ),
          ' ',
          icon
        );
      case 'cancel':
        icon = _react2.default.createElement(_SVGCross2.default, { viewBox: '0 0 20 20', size: 16 });
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver, icon: icon }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps({
            onClick: onClick,
            className: className,
            style: (0, _extends3.default)({ justifyContent: 'center', alignItems: 'center' }, style)
          })),
          children,
          ' ',
          icon
        );
      default:
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps({ onClick: onClick, className: className, style: style })),
          children
        );
    }
  };

  return renderChildren(type);
};
// import {getButtonStyles} from './defaultStyles'
exports.Button = Button;


Button.defaultProps = {
  settings: _defaultStyles.buttonStyles.vampire.borderless
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('isMouseOver', 'setIsMouseOver', false), (0, _recompose.setPropTypes)({
  //children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
  type: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  isMouseOver: _propTypes2.default.bool.isRequired,
  setIsMouseOver: _propTypes2.default.func.isRequired
}), (0, _recompose.onlyUpdateForKeys)(['isOn', 'isMouseOver']));

exports.default = enhance(Button);