'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMany = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

var _defaultStyles = require('./defaultStyles');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { Button } from './Button'

var SelectMany = function SelectMany(_ref) {
  var sortingFunction = _ref.sortingFunction,
      _ref$showUnselectedOn = _ref.showUnselectedOnly,
      showUnselectedOnly = _ref$showUnselectedOn === undefined ? false : _ref$showUnselectedOn,
      shouldToggleOnHover = _ref.shouldToggleOnHover,
      transitionOptions = _ref.transitionOptions,
      onChange = _ref.onChange,
      _ref$triggerX = _ref.triggerX,
      triggerX = _ref$triggerX === undefined ? 12 : _ref$triggerX,
      _ref$basewidth = _ref.basewidth,
      basewidth = _ref$basewidth === undefined ? 10 : _ref$basewidth,
      debugMode = _ref.debugMode,
      buttonProps = _ref.buttonProps,
      children = _ref.children,
      clearCurrent = _ref.clearCurrent,
      className = _ref.className,
      pivotFrom = _ref.pivotFrom,
      _renderTrigger = _ref.renderTrigger,
      currentOptions = _ref.currentOptions,
      addToCurrent = _ref.addToCurrent,
      removeFromCurrent = _ref.removeFromCurrent;

  var getChildProps = function getChildProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

    var isActive = function isActive(option) {
      return currentOptions.some(function (currentOption) {
        return currentOption.value === option.value;
      });
    };

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();

        if (currentOptions.map(function (currentOption) {
          return currentOption.value;
        }).includes(option.value)) {
          removeFromCurrent(option);
          onChange(currentOptions.filter(function (currentOption) {
            return currentOption.value !== option.value;
          }));
        } else {
          addToCurrent(option);
          if (sortingFunction) {
            onChange([].concat((0, _toConsumableArray3.default)(currentOptions), [option]).sort(sortingFunction));
          } else {
            onChange([].concat((0, _toConsumableArray3.default)(currentOptions), [option]));
          }
        }
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), 'selectmany__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : ''),
      style: style
    }, props);
  };
  var getButtonWidth = function getButtonWidth() {
    return (currentOptions.length >= 3 ? triggerX * 2.5 : currentOptions.length === 0 ? triggerX : triggerX * currentOptions.length) + 'rem';
  };
  return _react2.default.createElement(
    _DropdownPopover2.default,
    {
      debugMode: debugMode,
      pivotFrom: pivotFrom,
      transitionOptions: transitionOptions,
      shouldToggleOnHover: shouldToggleOnHover,
      triggerX: triggerX,
      basewidth: basewidth,
      renderTrigger: function renderTrigger(_ref3) {
        var isOn = _ref3.isOn,
            _getTriggerProps = _ref3.getTriggerProps;
        return _renderTrigger ? _renderTrigger({
          activeChildren: currentOptions.map(function (currentOption) {
            return currentOption.label;
          }).join(', '),
          isOn: isOn,
          getTriggerProps: function getTriggerProps() {
            var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var className = _ref4.className,
                style = _ref4.style,
                props = (0, _objectWithoutProperties3.default)(_ref4, ['className', 'style']);
            return _getTriggerProps((0, _extends3.default)({
              className: 'selectmany__trigger ' + (className ? className : ''),
              style: { width: triggerX + 'rem' }
            }, props));
          }
        }) : _react2.default.createElement(
          _Button2.default,
          {
            type: 'caretdropdown',
            isOn: isOn,

            settings: _defaultStyles.buttonStyles.mild.default
          },
          function (_ref5) {
            var getButtonProps = _ref5.getButtonProps,
                icon = _ref5.icon;
            return _react2.default.createElement(
              'div',
              (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({}, _getTriggerProps({
                className: 'selectmany__trigger',
                style: {
                  width: getButtonWidth(),
                  display: 'flex',
                  justifyContent: 'space-between',
                  padding: '0.5rem 0.75rem'
                }
              })))),
              _react2.default.createElement(
                'div',
                {
                  style: {
                    display: 'flex',
                    flexWrap: 'wrap'
                  }
                },
                currentOptions.length > 0 ? currentOptions.map(function (option) {
                  return _react2.default.createElement(
                    'div',
                    {
                      key: option.value,
                      style: {
                        display: 'flex',
                        background: '#f3f3f3',
                        borderRadius: '0.25rem',
                        margin: '0.25rem 0.375rem'
                      }
                    },
                    _react2.default.createElement(
                      'div',
                      {
                        style: {
                          color: '#2b2b2b',
                          padding: '0.25rem 0.375rem'
                        }
                      },
                      option.label
                    ),
                    _react2.default.createElement(_Button2.default, {
                      type: 'cancel',
                      transition: 'contrast',
                      settings: _defaultStyles.buttonStyles.redden.borderless,
                      onClick: function onClick() {
                        removeFromCurrent(option);
                      }
                    })
                  );
                }) : _react2.default.createElement(
                  'div',
                  {
                    style: {
                      display: 'flex',
                      background: '#f3f3f3',
                      borderRadius: '0.25rem',
                      margin: '0.25rem 0.375rem'
                    }
                  },
                  _react2.default.createElement(
                    'div',
                    {
                      style: {
                        color: '#2b2b2b',
                        padding: '0.25rem 0.375rem'
                      }
                    },
                    'select one...'
                  )
                )
              ),
              _react2.default.createElement(
                'div',
                { style: { display: 'flex' } },
                _react2.default.createElement(_Button2.default, {
                  type: 'cancel',
                  transition: 'contrast',
                  settings: _defaultStyles.buttonStyles.redden.borderless,
                  onClick: function onClick() {
                    clearCurrent();
                  }
                }),
                icon
              )
            );
          }
        );
      },
      parentName: 'selectmany'
    },
    function (_ref6) {
      var toggle = _ref6.toggle;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        toggle: toggle,
        currentOptions: currentOptions
      }) : children.filter(function (option) {
        if (showUnselectedOnly) {
          if (!currentOptions.some(function (currentOption) {
            return currentOption.value === option.value;
          })) {
            return option;
          }
        } else {
          return option;
        }
      }).map(function (option) {
        return _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({}, getChildProps({ option: option }), {
            //onClick: toggle,
            settings: _defaultStyles.buttonStyles.monochrome.default,
            isOn: currentOptions.some(function (currentOption) {
              return currentOption.value === option.value;
            }),
            key: option.value
          }),
          option.label
        );
      });
    }
  );
};

exports.SelectMany = SelectMany;
SelectMany.propTypes = {};
SelectMany.defaultProps = {
  onChange: function onChange() {
    return console.log('onChange');
  },
  buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('currentOptions', 'setCurrentOptions', function (_ref7) {
  var _ref7$currentOptions = _ref7.currentOptions,
      currentOptions = _ref7$currentOptions === undefined ? [] : _ref7$currentOptions;
  return currentOptions;
}), (0, _recompose.withHandlers)({
  addToCurrent: function addToCurrent(_ref8) {
    var setCurrentOptions = _ref8.setCurrentOptions,
        sortingFunction = _ref8.sortingFunction;
    return function (option) {
      if (sortingFunction) {
        setCurrentOptions(function (x) {
          return [].concat((0, _toConsumableArray3.default)(x), [option]).sort(sortingFunction);
        });
      } else {
        setCurrentOptions(function (x) {
          return [].concat((0, _toConsumableArray3.default)(x), [option]);
        });
      }
    };
  },
  removeFromCurrent: function removeFromCurrent(_ref9) {
    var setCurrentOptions = _ref9.setCurrentOptions;
    return function (option) {
      return setCurrentOptions(function (currentOptions) {
        return currentOptions.filter(function (currentOption) {
          return currentOption.value !== option.value;
        });
      });
    };
  },
  clearCurrent: function clearCurrent(_ref10) {
    var setCurrentOptions = _ref10.setCurrentOptions;
    return function () {
      return setCurrentOptions([]);
    };
  }
}));

exports.default = enhance(SelectMany);