'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectOne = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectOne = function SelectOne(_ref) {
  var shouldToggleOnHover = _ref.shouldToggleOnHover,
      transitionOptions = _ref.transitionOptions,
      onChange = _ref.onChange,
      _ref$triggerX = _ref.triggerX,
      triggerX = _ref$triggerX === undefined ? 5 : _ref$triggerX,
      _ref$paddingX = _ref.paddingX,
      paddingX = _ref$paddingX === undefined ? 0 : _ref$paddingX,
      _ref$basewidth = _ref.basewidth,
      basewidth = _ref$basewidth === undefined ? 20 : _ref$basewidth,
      children = _ref.children,
      pivotFrom = _ref.pivotFrom,
      debugMode = _ref.debugMode,
      _renderTrigger = _ref.renderTrigger,
      currentOption = _ref.currentOption,
      setCurrentOption = _ref.setCurrentOption,
      _ref$showCurrentOptio = _ref.showCurrentOption,
      showCurrentOption = _ref$showCurrentOptio === undefined ? false : _ref$showCurrentOptio,
      options = _ref.options;

  var getChildProps = function getChildProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

    var isActive = function isActive(option) {
      return option.value === currentOption.value;
    };
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        setCurrentOption(option);
        onChange(option);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), 'selectone__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : ''),
      style: (0, _extends3.default)({
        display: showCurrentOption === false && isActive(option) ? 'none' : 'flex'

      }, style)
    }, props);
  };
  return _react2.default.createElement(
    _DropdownPopover2.default,
    {
      triggerX: triggerX,
      paddingX: paddingX,
      basewidth: basewidth,
      debugMode: debugMode,
      pivotFrom: pivotFrom,
      transitionOptions: transitionOptions,
      shouldToggleOnHover: shouldToggleOnHover,
      renderTrigger: function renderTrigger(_ref3) {
        var isOn = _ref3.isOn,
            _getTriggerProps = _ref3.getTriggerProps;
        return _renderTrigger ? _renderTrigger({
          currentOption: currentOption,
          isOn: isOn,
          getTriggerProps: function getTriggerProps() {
            var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var className = _ref4.className,
                props = (0, _objectWithoutProperties3.default)(_ref4, ['className']);
            return _getTriggerProps((0, _extends3.default)({
              className: 'selectone__trigger ' + (className ? className : ''),
              style: { width: triggerX + 'rem' }
            }, props));
          }
        }) : _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            type: 'caretdropdown',
            isOn: isOn
          }, _getTriggerProps({
            className: 'selectone__trigger',
            style: { width: triggerX + 'rem' }
          }), {
            settings: _defaultStyles.buttonStyles.monochrome.borderless
          }),
          options.find(function (option) {
            return option.value === currentOption.value;
          }).label
        );
      },
      parentName: 'select'
    },
    function (_ref5) {
      var toggle = _ref5.toggle;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        toggle: toggle,
        currentOption: currentOption
      }) : children.map(function (option) {
        return _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({}, getChildProps({
            option: { value: option.value, label: option.label },
            onClick: toggle
          }), {

            settings: _defaultStyles.buttonStyles.monochrome.default,
            isOn: currentOption.value === option.value,
            key: option.value
          }),
          option.label
        );
      });
    }
  );
};

exports.SelectOne = SelectOne;
SelectOne.propTypes = {};
SelectOne.defaultProps = {
  buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('currentOption', 'setCurrentOption', function (_ref6) {
  var currentOption = _ref6.currentOption;
  return currentOption;
}));

exports.default = enhance(SelectOne);