'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultStyles = exports.buttonStyles = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buttonStyles = exports.buttonStyles = {
  vivid: {
    borderless: {
      on: { background: '#33aaff', color: '#eeeeee' },
      off: { background: '#ffbb33', color: '#333333' },
      diff: 30,
      constant: { padding: '0.5rem 0.75rem' }
    }
  },
  neutral: {
    borderless: {
      on: { background: 'none', color: '#eeeeee' },
      off: { background: 'none', color: '#333333' },
      diff: 30
    }
  },
  vampire: {
    borderless: {
      on: { background: '#bb2222', color: '#eeeeee' },
      off: { background: '#e4e4e4', color: '#333333' },
      diff: 20,
      constant: { padding: '0.5rem 0.75rem' }
    }
  },
  redden: {
    borderless: {
      on: { background: '#dd8888', color: '#eeeeee' },
      off: { background: 'none', color: '#333333' },
      diff: 20
    }
  },
  monochrome: {
    borderless: {
      on: { background: '#333333', color: '#f4f4f4' },
      off: { background: '#fafafa', color: '#333333' },
      diff: 20
    },
    default: {
      on: { background: '#eeffff', color: '#111111' },
      off: { background: '#fafafa', color: '#111111' },
      diff: 10,
      constant: {
        borderColor: '#d9d9d9 #ccc #b3b3b3',
        borderWidth: '1',
        borderStyle: 'solid',
        padding: '0.5rem 0.75rem'
      }
    }
  },
  mild: {
    borderless: {
      on: { background: '#eeffff', color: '#f4f4f4' },
      off: { background: '#fafafa', color: '#333333' },
      diff: 10
    },
    default: {
      on: { background: '#eeffff', color: '#333333' },
      off: { background: '#fafafa', color: '#333333' },
      diff: 10,
      constant: {
        borderColor: '#d9d9d9 #ccc #b3b3b3',
        borderWidth: '1',
        borderStyle: 'solid',
        padding: '0.5rem 0.75rem'
      }
    }
  }
};

var defaultStyles = exports.defaultStyles = {
  container: {
    position: 'relative',
    alignItems: 'center',
    cursor: 'default',
    display: 'flex',
    flex: '0 1 auto',
    flexDirection: 'column',
    margin: '0 1rem',
    opacity: '1',
    color: 'black',
    background: 'rgba(245, 245, 245, 0.85)',
    border: '1px solid #575757',
    zIndex: '2',
    borderRadius: '0.5rem'
  },
  body: {
    display: 'flex',
    flexDirection: 'column',
    background: '#fdfdfd',
    flex: '1 1 auto',
    padding: '2.4rem 1.2rem',
    borderRadius: '0 0 1rem 1rem',
    overflowY: 'auto'
  },
  background: {
    position: 'fixed',
    height: '100%',
    top: '0',
    left: '0',
    width: '100%',
    background: 'rgba(0, 0, 0, 0.5)',
    zIndex: '4',
    opacity: '1',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    WebkitTapHighlightColor: 'transparent'
  },
  header: {
    margin: '0',
    padding: '2rem 2rem 1.5rem 2rem',
    borderBottom: '0.5rem solid #f0f0f0',
    background: '#fafafa'
  },
  buttons: {
    borderTop: '1px solid #575757',
    padding: '0.5rem 0',
    width: '100%',
    background: 'white',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'flex-end'
  },
  closemodalbutton: {
    top: '0.5rem',
    right: '0.5rem',
    cursor: 'pointer',
    position: 'absolute',
    background: 'white',
    borderRadius: '100%',
    display: 'flex',
    flexDirection: 'row-reverse'
  }
};